package su.a71.new_soviet.mixin.client;

import net.minecraft.client.color.block.BlockColors;
import net.minecraft.client.render.model.ModelLoader;
import net.minecraft.client.render.model.json.JsonUnbakedModel;
import net.minecraft.client.util.ModelIdentifier;
import net.minecraft.util.Identifier;
import net.minecraft.util.profiler.Profiler;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import su.a71.new_soviet.NewSoviet;

import java.util.List;
import java.util.Map;

@Mixin(ModelLoader.class)
public abstract class ModelLoaderMixin {
    @Shadow
    protected abstract void addModel(ModelIdentifier modelId);

    @Inject(method = "<init>", at = @At(value = "INVOKE", target = "Lnet/minecraft/client/render/model/ModelLoader;addModel(Lnet/minecraft/client/util/ModelIdentifier;)V", ordinal = 3, shift = At.Shift.AFTER))
    public void addModels(BlockColors blockColors, Profiler profiler, Map<Identifier, JsonUnbakedModel> jsonUnbakedModels, Map<Identifier, List<ModelLoader.SourceTrackedData>> blockStates, CallbackInfo ci) {
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "cigarette_item", "inventory"));

        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "oak_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "acacia_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "acacia_pane_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "birch_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "birch_pane_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "cherry_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "cherry_pane_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "crimson_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "crimson_pane_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "dark_oak_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "dark_oak_pane_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "jungle_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "jungle_pane_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "mangrove_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "mangrove_pane_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "oak_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "oak_pane_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "spruce_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "spruce_pane_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "warped_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "warped_pane_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "whitewashed_window_item", "inventory"));
        this.addModel(new ModelIdentifier(NewSoviet.MOD_ID, "whitewashed_pane_window_item", "inventory"));
    }
}